## qpdf 11.8.0

=== debian/changelog ===
qpdf (11.8.0-1) unstable; urgency=medium

  * New upstream release.

 -- Jay Berkenbilt <qjb@debian.org>  Mon, 08 Jan 2024 12:48:05 -0500

qpdf (11.7.0-4) unstable; urgency=medium

  * Fix debian/rules to correctly support arch=all build

 -- Jay Berkenbilt <qjb@debian.org>  Sat, 30 Dec 2023 10:00:13 -0500

qpdf (11.7.0-3) unstable; urgency=medium

  * No changes -- source-only upload to unblock migration.

 -- Jay Berkenbilt <qjb@debian.org>  Fri, 29 Dec 2023 12:52:45 -0500

qpdf (11.7.0-2) unstable; urgency=medium

  * Fix handling of documentation build to correctly handle
    architecture-only builds.

 -- Jay Berkenbilt <qjb@debian.org>  Sun, 24 Dec 2023 16:09:13 -0500

qpdf (11.7.0-1) unstable; urgency=medium

  * New upstream realease.
  * Build qpdf-doc package. This is possible now that a sufficient new
    sphinx_rtd_theme is packaged. (Closes: #1004159)

 -- Jay Berkenbilt <qjb@debian.org>  Sun, 24 Dec 2023 10:05:35 -0500

qpdf (11.6.4-1) unstable; urgency=medium

  * New upstream release.

 -- Jay Berkenbilt <qjb@debian.org>  Sun, 10 Dec 2023 12:12:09 -0500

qpdf (11.6.3-1) unstable; urgency=medium

  * New upstream release.

 -- Jay Berkenbilt <qjb@debian.org>  Sun, 15 Oct 2023 15:52:09 -0400

qpdf (11.6.2-2) unstable; urgency=medium

  * Tweak cmake syntax: use ON and OFF instead of 1 and 0. This doesn't
    change any functionality, but it is more standard, and I hope it
    addresses the FTBFS in reproducible_builds.

 -- Jay Berkenbilt <qjb@debian.org>  Sun, 08 Oct 2023 09:04:41 -0400

qpdf (11.6.2-1) unstable; urgency=medium

  * New upstream release.

 -- Jay Berkenbilt <qjb@debian.org>  Sat, 07 Oct 2023 18:33:33 -0400

=== debian/control ===
Source: qpdf
Section: libs
Priority: optional
Build-Depends: cmake (>= 3.16~), debhelper (>> 10.3~),
 libjpeg-dev, zlib1g-dev, libgnutls28-dev,
Build-Depends-Indep:
 python3-sphinx, python3-sphinx-rtd-theme (>= 1~),
 libjs-sphinxdoc (>= 4.3.2~),
 texlive, texlive-latex-extra, latexmk, tex-gyre
Maintainer: Jay Berkenbilt <qjb@debian.org>
Standards-Version: 4.6.2
Homepage: https://qpdf.sourceforge.io

Package: libqpdf29
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: runtime library for PDF transformation/inspection software
 QPDF is a program that can be used to linearize (web-optimize),
 encrypt (password-protect), decrypt, and inspect PDF files from the
 command-line.  It does these and other structural, content-preserving
 transformations on PDF files, reading a PDF file as input and
 creating a new one as output.  It also provides many useful
 capabilities to developers of PDF-producing software or for people
 who just want to look at the innards of a PDF file to learn more
 about how they work.
 .
 QPDF understands PDF files that use compressed object streams
 (supported by newer PDF applications) and can convert such files into
 those that can be read with older viewers.  It can also be used for
 checking PDF files for structural errors, inspecting stream contents,
 or extracting objects from PDF files.  QPDF is not PDF content
 creation or viewing software -- it does not have the capability to
 create PDF files from scratch or to display PDF files.
 .
 This package contains the qpdf runtime libraries required to run
 programs that link with the qpdf library.

Package: libqpdf-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, libqpdf29 (= ${binary:Version}), libjpeg-dev, zlib1g-dev
Suggests: qpdf-doc
Description: development files for PDF transformation/inspection library
 QPDF is a program that can be used to linearize (web-optimize),
 encrypt (password-protect), decrypt, and inspect PDF files from the
 command-line.  It does these and other structural, content-preserving
 transformations on PDF files, reading a PDF file as input and
 creating a new one as output.  It also provides many useful
 capabilities to developers of PDF-producing software or for people
 who just want to look at the innards of a PDF file to learn more
 about how they work.
 .
 QPDF understands PDF files that use compressed object streams
 (supported by newer PDF applications) and can convert such files into
 those that can be read with older viewers.  It can also be used for
 checking PDF files for structural errors, inspecting stream contents,
 or extracting objects from PDF files.  QPDF is not PDF content
 creation or viewing software -- it does not have the capability to
 create PDF files from scratch or to display PDF files.
 .
 This package includes all development files needed to compile
 applications that use the qpdf library.

Package: qpdf
Section: text
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: qpdf-doc
Description: tools for transforming and inspecting PDF files
 QPDF is a program that can be used to linearize (web-optimize),
 encrypt (password-protect), decrypt, and inspect PDF files from the
 command-line.  It does these and other structural, content-preserving
 transformations on PDF files, reading a PDF file as input and
 creating a new one as output.  It also provides many useful
 capabilities to developers of PDF-producing software or for people
 who just want to look at the innards of a PDF file to learn more
 about how they work.
 .
 QPDF understands PDF files that use compressed object streams
 (supported by newer PDF applications) and can convert such files into
 those that can be read with older viewers.  It can also be used for
 checking PDF files for structural errors, inspecting stream contents,
 or extracting objects from PDF files.  QPDF is not PDF content
 creation or viewing software -- it does not have the capability to
 create PDF files from scratch or to display PDF files.
 .
 This package includes the command-line qpdf tools.

Package: qpdf-doc
Section: text
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}, ${sphinxdoc:Depends}
Description: tools for transforming and inspecting PDF files
 QPDF is a program that can be used to linearize (web-optimize),
 encrypt (password-protect), decrypt, and inspect PDF files from the
 command-line.  It does these and other structural, content-preserving
 transformations on PDF files, reading a PDF file as input and
 creating a new one as output.  It also provides many useful
 capabilities to developers of PDF-producing software or for people
 who just want to look at the innards of a PDF file to learn more
 about how they work.
 .
 QPDF understands PDF files that use compressed object streams
 (supported by newer PDF applications) and can convert such files into
 those that can be read with older viewers.  It can also be used for
 checking PDF files for structural errors, inspecting stream contents,
 or extracting objects from PDF files.  QPDF is not PDF content
 creation or viewing software -- it does not have the capability to
 create PDF files from scratch or to display PDF files.
 .
 This package includes the full qpdf manual.

## qpdf 11.9.0

=== CMakeLists.txt ===
# manual/installation.rst mentions the minimum cmake version.
cmake_minimum_required(VERSION 3.16)

# make_dist expects the version line to be on a line by itself after
# the project line. When updating the version, check make_dist for all
# the places it has to be updated. The doc configuration and CI build
# also find the version number here. generate_auto_job also reads the
# version from here.
project(qpdf
  VERSION 11.9.0
  LANGUAGES C CXX)

# Enable correct rpath handling for MacOSX
cmake_policy(SET CMP0042 NEW)
# Honor CMAKE_REQUIRED_LIBRARIES when checking for include files
cmake_policy(SET CMP0075 NEW)

# *** OPTIONS ***

# Keep all options here. It's easier to see the interdependencies this
# way than spreading them throughout the files.
#
# ***** Keep manual/installation.rst (_build-options) up to date. *****

include(CMakeDependentOption)

# CMAKE_DEPENDENT_OPTION(
#   OPTION "Description" default-value-if-visible
#   "when-visible" value-if-not-visible)

# Don't write tests based on MAINTAINER_MODE or CI_MODE. Instead, use
# them as the basis for dependent options.

option(MAINTAINER_MODE "Set options for developing qpdf" OFF)
CMAKE_DEPENDENT_OPTION(
  CI_MODE "Set options for running in CI" OFF
  "NOT MAINTAINER_MODE" OFF)
CMAKE_DEPENDENT_OPTION(
  WERROR "Treat compiler warnings as errors" OFF
  "NOT MAINTAINER_MODE; NOT CI_MODE" ON)
CMAKE_DEPENDENT_OPTION(
  CHECK_SIZES "Compare sizes.cc with classes in public API" OFF
  "NOT MAINTAINER_MODE" ON)
CMAKE_DEPENDENT_OPTION(
  GENERATE_AUTO_JOB "Automatically regenerate job files" OFF
  "NOT MAINTAINER_MODE" ON)
CMAKE_DEPENDENT_OPTION(
  ENABLE_QTC "Enable QTC test coverage" OFF
  "NOT MAINTAINER_MODE" ON)
CMAKE_DEPENDENT_OPTION(
  SHOW_FAILED_TEST_OUTPUT "Show qtest output on failure" OFF
  "NOT CI_MODE" ON)

# To allow building doc to be disabled in maintainer mode, handle the
# condition manually rather than using a dependent option.
if(MAINTAINER_MODE)
  set(default_BUILD_DOC ON)
else()
  set(default_BUILD_DOC OFF)
endif()
option(BUILD_DOC "Build documentation" ${default_BUILD_DOC})
# The values of BUILD_DOC_HTML and BUILD_DOC_PDF are ignored without
# BUILD_DOC, so setting them to ON when not visible forces them to be
# on in MAINTAINER_MODE and is harmless if BUILD_DOC is off.
CMAKE_DEPENDENT_OPTION(
  BUILD_DOC_HTML "Build HTML documentation"
  ON "BUILD_DOC;NOT MAINTAINER_MODE" ON)
CMAKE_DEPENDENT_OPTION(
  BUILD_DOC_PDF "Build PDF documentation"
  ON "BUILD_DOC;NOT MAINTAINER_MODE" ON)
CMAKE_DEPENDENT_OPTION(
  BUILD_DOC_DIST "Create distribution of manual" ON
  "BUILD_DOC_PDF;BUILD_DOC_HTML" OFF)

option(ENABLE_COVERAGE "Enable coverage reporting" OFF)
option(BUILD_SHARED_LIBS "Build qpdf shared libraries" ON)
option(BUILD_STATIC_LIBS "Build qpdf static libraries" ON)
option(QTEST_COLOR "Whether qtest's output should be in color" ON)
option(USE_INSECURE_RANDOM "Use insecure random numbers" OFF)
option(SKIP_OS_SECURE_RANDOM
  "Suppress use of OS-provided secure random numbers" OFF)
CMAKE_DEPENDENT_OPTION(
  AVOID_WINDOWS_HANDLE "Avoid use of HANDLE in Windows" OFF
  "WIN32" OFF)

option(OSS_FUZZ "Specific build configuration for the oss-fuzz project" OFF)

option(USE_IMPLICIT_CRYPTO "Enable any available external crypto provider" ON)
CMAKE_DEPENDENT_OPTION(
  ALLOW_CRYPTO_NATIVE "Allow native crypto as as fallback" ON
  "USE_IMPLICIT_CRYPTO" OFF)
CMAKE_DEPENDENT_OPTION(
  REQUIRE_CRYPTO_NATIVE "Require native crypto provider" OFF
  "NOT MAINTAINER_MODE; NOT CI_MODE" ON)
option(REQUIRE_CRYPTO_OPENSSL "Require openssl crypto" OFF)
option(REQUIRE_CRYPTO_GNUTLS "Require gnutls crypto" OFF)
set(DEFAULT_CRYPTO CACHE STRING "")
option(DEFAULT_CRYPTO
  "Specify default crypto; otherwise chosen automatically" "")

# INSTALL_MANUAL is not dependent on building docs. When creating some
# distributions, we build the doc in one run, copy doc-dist in, and
# install it elsewhere.
option(INSTALL_MANUAL "Install documentation" OFF)

option(INSTALL_PKGCONFIG "Install pkgconfig file" ON)
option(INSTALL_CMAKE_PACKAGE "Install cmake package files" ON)
option(INSTALL_EXAMPLES "Install example files" ON)

option(FUTURE "Include ABI-breaking changes CONSIDERED for the next major release" OFF)
option(CXX_NEXT "Build with next C++ standard version" OFF)

# *** END OPTIONS ***

if(NOT (BUILD_STATIC_LIBS OR BUILD_SHARED_LIBS))
  message(
    FATAL_ERROR "At least one of static or shared libraries must be built")
endif()

set(CMAKE_INCLUDE_DIRECTORIES_PROJECT_BEFORE ON)
add_compile_definitions($<$<COMPILE_LANGUAGE:CXX>:POINTERHOLDER_TRANSITION=4>)

if(ENABLE_QTC)
  set(ENABLE_QTC_ARG)
else()
  add_compile_definitions(QPDF_DISABLE_QTC=1)
  set(ENABLE_QTC_ARG --disable-tc)
endif()

if(FUTURE)
  add_compile_definitions(QPDF_FUTURE=1)
endif()

enable_testing()
set(RUN_QTEST perl ${qpdf_SOURCE_DIR}/run-qtest ${ENABLE_QTC_ARG})

if(WIN32)
  find_program(COPY_COMMAND NAMES cp copy)
  if(COPY_COMMAND STREQUAL "COPY_COMMAND-NOTFOUND")
    set(COPY_COMMAND "copy")
  endif()
else()
  set(COPY_COMMAND "cp")
endif()

# For a long time, qpdf used libtool's version system. We are no
# longer doing that, but to avoid potential conflict with older
# versions, continue to have the shared library symlink point to a
# file whose version shares minor and patch with the project version
# and major with the SOVERSION. Starting with the transition to cmake,
# increment SOVERSION every time we increment the project major
# version. This works because qpdf uses semantic versioning. qpdf 10.x
# was libqpdf28, so start from there.

if(FUTURE)
  math(EXPR qpdf_SOVERSION 0)
  set(qpdf_LIBVERSION 0)
else()
  math(EXPR qpdf_SOVERSION "${PROJECT_VERSION_MAJOR} + 18")
  set(qpdf_LIBVERSION ${qpdf_SOVERSION}.${PROJECT_VERSION_MINOR}.${PROJECT_VERSION_PATCH})
endif()

if(${CMAKE_SOURCE_DIR} STREQUAL ${CMAKE_BINARY_DIR})
  message(FATAL_ERROR "
Please build with cmake in a subdirectory, e.g.
 mkdir build
 cmake ..
 cmake --build .
Please remove CMakeCache.txt and the CMakeFiles directories.")
endif()

if(CXX_NEXT)
  set(CMAKE_CXX_STANDARD 20)
else()
  set(CMAKE_CXX_STANDARD 17)
endif()
set(CMAKE_CXX_EXTENSIONS OFF)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_C_VISIBILITY_PRESET hidden)
set(CMAKE_CXX_VISIBILITY_PRESET hidden)

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/cmake")

if(WIN32 AND NOT SKIP_OS_SECURE_RANDOM)
  list(APPEND CMAKE_REQUIRED_LIBRARIES Advapi32)
endif()

include(CheckCXXSourceCompiles)
set(ATOMIC_LIBRARY)
function(check_atomic)
  foreach(I 0 1)
    if(I)
      set(CMAKE_REQUIRED_LIBRARIES atomic)
    endif()
    check_cxx_source_compiles(
      "#include <atomic>
int main() {
    static std::atomic<unsigned long long> a{0};
    a = a.fetch_add(1LL);
    return 0;
}"
      ATOMIC_WORKED${I})
    if(ATOMIC_WORKED0)
      return()
    endif()
  endforeach()
  if(ATOMIC_WORKED1)
    set(ATOMIC_LIBRARY atomic PARENT_SCOPE)
  endif()
endfunction()
check_atomic()

set(WINDOWS_WMAIN_COMPILE "")
set(WINDOWS_WMAIN_LINK "")
if(WIN32)
  function(check_wmain)
    foreach(I 0 1)
      if(NOT WINDOWS_WMAIN_COMPILE)
        if(I)
          set(CMAKE_REQUIRED_LINK_OPTIONS -municode)
        endif()
        check_cxx_source_compiles(
          "#include <windows.h>
#include <string.h>
#include <stdio.h>
extern \"C\"
int wmain(int argc, wchar_t* argv[])
{
    size_t x = wcslen(argv[0]);
    return 0;
}
"
          WMAIN_WORKED${I})
      endif()
    endforeach()
    if(WMAIN_WORKED1 OR WMAIN_WORKED1)
      set(WINDOWS_WMAIN_COMPILE -DWINDOWS_WMAIN PARENT_SCOPE)
      if(WMAIN_WORKED1 AND NOT WMAIN_WORKED0)
        set(WINDOWS_WMAIN_LINK -municode PARENT_SCOPE)
      endif()
    endif()
  endfunction()
  check_wmain()
endif()

if(MSVC)
  list(APPEND CMAKE_REQUIRED_LINK_OPTIONS -link setargv.obj)
  list(APPEND WINDOWS_WMAIN_LINK -link wsetargv.obj)
endif()

include(GNUInstallDirs)

# Compiler flags
#
# **NOTE** -- each flag must have its own cache variable.

include(qpdfCheckFlag)
if(WERROR)
  if(MSVC)
    add_compile_options(/WX)
  else()
    qpdf_maybe_add_flag(C -Werror flag_werror)
  endif()
endif()

if(MSVC)
  # /Gy combines identical functions -- useful with C++ templates
  add_compile_options(/Gy)
  add_compile_options(/W3)    # warning level 3
else()
  qpdf_maybe_add_flag(C -Wall flag_wall)
  qpdf_maybe_add_flag(C -Wconversion flag_conversion)
  qpdf_maybe_add_flag(C -Wsign-conversion flag_sign-conversion)
  qpdf_maybe_add_flag(C -Wshadow=local flag_shadow_local)
  qpdf_maybe_add_flag(CXX -Wold-style-cast flag_old-style-cast)
endif()

# We don't include the jpeg library's include path in the PUBLIC
# interface for libqpdf since only Pl_DCT.hh requires it. This is
# documented. Some examples and tests use it though so we have to
# define it. CMakeLists.txt for libqpdf sets the value for
# JPEG_INCLUDE which can be selectively added to include paths other
# tools.
set(JPEG_INCLUDE)

if(${CMAKE_SIZEOF_VOID_P} EQUAL 8)
  set(WORDSIZE 64)
else()
  set(WORDSIZE 32)
endif()
if(MSVC)
  set(CPACK_SYSTEM_NAME "msvc${WORDSIZE}")
elseif(MINGW)
  set(CPACK_SYSTEM_NAME "mingw${WORDSIZE}")
endif()
set(CPACK_RESOURCE_FILE_LICENSE "${qpdf_SOURCE_DIR}/LICENSE.txt")
set(CPACK_PACKAGE_HOMEPAGE_URL "https://qpdf.sourceforge.io/")
set(CPACK_NSIS_MUI_ICON "${qpdf_SOURCE_DIR}/logo/qpdf.ico")

if(ENABLE_COVERAGE)
  add_compile_options(--coverage -O0)
  add_link_options(--coverage)
endif()

include(CPack)

# Install components -- documented in _installation in
# manual/installation.rst.
set(COMPONENT_DEV "dev")
set(COMPONENT_LIB "lib") # runtime library
set(COMPONENT_CLI "cli")
set(COMPONENT_DOC "doc")
set(COMPONENT_EXAMPLES "examples") # example sources

if(WIN32)
  include(InstallRequiredSystemLibraries)
endif()

set(auto_job_inputs
  # Keep in sync with SOURCES in generate_auto_job
  generate_auto_job
  CMakeLists.txt
  manual/_ext/qpdf.py
  job.yml
  manual/cli.rst
  manual/qpdf.1.in
)

set(auto_job_outputs
  # Keep in sync with DESTS in generate_auto_job
  libqpdf/qpdf/auto_job_decl.hh
  libqpdf/qpdf/auto_job_init.hh
  libqpdf/qpdf/auto_job_help.hh
  libqpdf/qpdf/auto_job_schema.hh
  libqpdf/qpdf/auto_job_json_decl.hh
  libqpdf/qpdf/auto_job_json_init.hh
  manual/qpdf.1
)

if(GENERATE_AUTO_JOB)
  add_custom_command(
    OUTPUT ${auto_job_outputs}
    COMMAND ${qpdf_SOURCE_DIR}/generate_auto_job --generate
    WORKING_DIRECTORY ${qpdf_SOURCE_DIR}
    DEPENDS ${auto_job_inputs})
  add_custom_target(auto_job_files ALL DEPENDS ${auto_job_outputs})
endif()

add_test(
  NAME check-assert
  COMMAND perl ${qpdf_SOURCE_DIR}/check_assert)

# add_subdirectory order affects test order
add_subdirectory(include)
add_subdirectory(libqpdf)
add_subdirectory(compare-for-test)
add_subdirectory(qpdf)
add_subdirectory(libtests)
add_subdirectory(examples)
add_subdirectory(zlib-flate)
add_subdirectory(manual)
add_subdirectory(fuzz)

# We don't need to show everything -- just the things that we really
# need to be sure are right or that are turned on or off with complex
# logic.
get_property(MULTI_CONFIG GLOBAL PROPERTY GENERATOR_IS_MULTI_CONFIG)
message(STATUS "")
message(STATUS "*** Summary ***")
message(STATUS "  qpdf version: ${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}.${PROJECT_VERSION_PATCH}")
if(MULTI_CONFIG)
  message(STATUS "  build type: specify --config at build time")
elseif(CMAKE_BUILD_TYPE)
  message(STATUS "  build type: ${CMAKE_BUILD_TYPE}")
endif()
message(STATUS "  build shared libraries: ${BUILD_SHARED_LIBS}")
message(STATUS "  build static libraries: ${BUILD_STATIC_LIBS}")
message(STATUS "  build manual: ${BUILD_DOC}")
message(STATUS "  compiler warnings are errors: ${WERROR}")
message(STATUS "  QTC test coverage: ${ENABLE_QTC}")
message(STATUS "  include future changes: ${FUTURE}")
message(STATUS "  system: ${CPACK_SYSTEM_NAME}")
message(STATUS "")
message(STATUS "*** Options Summary ***")
foreach(PROP
    COMPILE_OPTIONS INTERFACE_COMPILE_OPTIONS
    COMPILE_DEFINITIONS INTERFACE_COMPILE_DEFINITIONS

=== zlib-flate/CMakeLists.txt ===
add_executable(zlib-flate zlib-flate.cc)
target_link_libraries(zlib-flate libqpdf)

add_test(
  NAME zlib-flate
  COMMAND ${RUN_QTEST}
  --top ${qpdf_SOURCE_DIR}
  --bin $<TARGET_FILE_DIR:zlib-flate>
  --bin $<TARGET_FILE_DIR:libqpdf>  # for Windows to find DLL
  --code ${qpdf_SOURCE_DIR}/zlib-flate
  --color ${QTEST_COLOR}
  --show-on-failure ${SHOW_FAILED_TEST_OUTPUT})

install(TARGETS zlib-flate
  TYPE RUNTIME
  COMPONENT ${COMPONENT_CLI})

=== debian/changelog ===
qpdf (11.9.0-1.1ubuntu0.1) noble; urgency=medium

  * d/p/lp2129676-relax-fips-for-pdfs.patch: Utilize the
    GNUTLS_FIPS140_LAX around MD5 initialization. (LP: #2129676)
  * d/p/lp2131944-fix-failing-tests-on-s390x.patch: Fix failing tests on
    s390x due to different error output. (LP: #2131944)

 -- Dariusz Gadomski <dgadomski@ubuntu.com>  Mon, 24 Nov 2025 13:52:26 +0100

qpdf (11.9.0-1.1build1) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 08:17:11 +0000

qpdf (11.9.0-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1062719

 -- Benjamin Drung <bdrung@debian.org>  Thu, 29 Feb 2024 21:38:49 +0000

qpdf (11.9.0-1) unstable; urgency=medium

  * New upstream release.

 -- Jay Berkenbilt <qjb@debian.org>  Sat, 24 Feb 2024 16:31:27 -0500

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1
# To skip tests:
#export DEB_BUILD_OPTIONS=nocheck

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

COMMON_CONFIG = \
  -DCMAKE_BUILD_RPATH_USE_ORIGIN=ON \
  -DUSE_IMPLICIT_CRYPTO=OFF -DREQUIRE_CRYPTO_GNUTLS=ON \
  -DSHOW_FAILED_TEST_OUTPUT=ON -DCMAKE_BUILD_TYPE=RelWithDebInfo \
  -DQTEST_COLOR=OFF

SPHINX_VERSION != sphinx-build --version 2>/dev/null
ifeq ($(.SHELLSTATUS), 0)
  DOC_CONFIG = -DBUILD_DOC=ON -DINSTALL_MANUAL=ON
else
  DOC_CONFIG =
endif

%:
	dh $@

override_dh_compress:
	dh_compress --exclude examples/ --exclude qpdf-manual.pdf

override_dh_auto_configure:
	dh_auto_configure -- $(COMMON_CONFIG) $(DOC_CONFIG)

# This target is not run for arch only builds
execute_after_dh_auto_configure-indep:
	if test "$(SPHINX_VERSION)" = ""; then \
	    echo '*** sphinx is missing ***'; \
	fi

override_dh_auto_test:
	if [ "$(DEB_HOST_ARCH)" = "s390x" ]; then \
		cp $(CURDIR)/qpdf/qtest/qpdf/fuzz-16214-s390x.out $(CURDIR)/qpdf/qtest/qpdf/fuzz-16214.out ; \
	fi
	dh_auto_test

override_dh_install:
	rm -rf debian/tmp/usr/share/doc/qpdf/manual-single-page-html
	(echo 'Complete documentation for qpdf can be found in the qpdf-doc package or'; \
	 echo 'online at https://qpdf.readthedocs.io') \
	 > debian/tmp/usr/share/doc/qpdf/README-doc.txt
	mkdir -p debian/tmp/usr/share/doc/libqpdf-dev
	mv debian/tmp/usr/share/doc/qpdf/examples \
	    debian/tmp/usr/share/doc/libqpdf-dev/
	cp -p README.md debian/tmp/usr/share/doc/libqpdf-dev/README.md
	mkdir -p debian/tmp/usr/share/bash-completion/completions
	cp completions/bash/qpdf \
	    debian/tmp/usr/share/bash-completion/completions/qpdf
	mkdir -p debian/tmp/usr/share/zsh/vendor-completions
	cp completions/zsh/_qpdf \
	    debian/tmp/usr/share/zsh/vendor-completions/_qpdf
	dh_install
	if test "$(SPHINX_VERSION)" != ""; then \
	    dh_sphinxdoc; \
	fi
	dh_missing --list-missing

## qpdf 11.9.1

=== debian/changelog ===
qpdf (11.9.1-1) unstable; urgency=medium

  * New upstream release.

 -- Jay Berkenbilt <qjb@debian.org>  Fri, 07 Jun 2024 10:51:16 -0400

qpdf (11.9.0-2) unstable; urgency=medium

  * Incorporate NMU changes, now that they have migrated to testing.

 -- Jay Berkenbilt <qjb@debian.org>  Sun, 28 Apr 2024 14:02:33 -0400

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,7 @@
 Source: qpdf
 Section: libs
 Priority: optional
-Build-Depends: cmake (>= 3.16~), debhelper (>> 10.3~),
+Build-Depends: dpkg-dev (>= 1.22.5), cmake (>= 3.16~), debhelper (>> 10.3~),
  libjpeg-dev, zlib1g-dev, libgnutls28-dev,
 Build-Depends-Indep:
  python3-sphinx, python3-sphinx-rtd-theme (>= 1~),
@@ -11,7 +11,10 @@
 Standards-Version: 4.6.2
 Homepage: https://qpdf.sourceforge.io
 
-Package: libqpdf29
+Package: libqpdf29t64
+Provides: ${t64:Provides}
+Replaces: libqpdf29
+Breaks: libqpdf29 (<< ${source:Version})
 Section: libs
 Architecture: any
 Multi-Arch: same
@@ -43,7 +46,7 @@
 Architecture: any
 Multi-Arch: same
 Pre-Depends: ${misc:Pre-Depends}
-Depends: ${misc:Depends}, libqpdf29 (= ${binary:Version}), libjpeg-dev, zlib1g-dev
+Depends: ${misc:Depends}, libqpdf29t64 (= ${binary:Version}), libjpeg-dev, zlib1g-dev
 Suggests: qpdf-doc
 Description: development files for PDF transformation/inspection library
  QPDF is a program that can be used to linearize (web-optimize),

## qpdf 11.10.1

=== debian/changelog ===
qpdf (11.10.1-1) unstable; urgency=medium

  * New upstream release.

 -- Jay Berkenbilt <qjb@debian.org>  Sat, 15 Feb 2025 17:48:30 -0500

qpdf (11.10.0-1) unstable; urgency=medium

  * New upstream release.

 -- Jay Berkenbilt <qjb@debian.org>  Sat, 08 Feb 2025 15:39:36 -0500

## qpdf 12.0.0

=== libqpdf/CMakeLists.txt ===
set(libqpdf_crypto_native
  AES_PDF_native.cc
  MD5_native.cc
  QPDFCrypto_native.cc
  RC4_native.cc
  SHA2_native.cc
  rijndael.cc
  sha2.c
  sha2big.c)

set(libqpdf_crypto_openssl
  QPDFCrypto_openssl.cc)

set(libqpdf_crypto_gnutls
  QPDFCrypto_gnutls.cc)

set(libqpdf_SOURCES
  BitStream.cc
  BitWriter.cc
  Buffer.cc
  BufferInputSource.cc
  ClosedFileInputSource.cc
  ContentNormalizer.cc
  CryptoRandomDataProvider.cc
  FileInputSource.cc
  InputSource.cc
  InsecureRandomDataProvider.cc
  JSON.cc
  JSONHandler.cc
  MD5.cc
  NNTree.cc
  OffsetInputSource.cc
  PDFVersion.cc
  Pipeline.cc
  Pl_AES_PDF.cc
  Pl_ASCII85Decoder.cc
  Pl_ASCIIHexDecoder.cc
  Pl_Base64.cc
  Pl_Buffer.cc
  Pl_Concatenate.cc
  Pl_Count.cc
  Pl_DCT.cc
  Pl_Discard.cc
  Pl_Flate.cc
  Pl_Function.cc
  Pl_LZWDecoder.cc
  Pl_MD5.cc
  Pl_OStream.cc
  Pl_PNGFilter.cc
  Pl_QPDFTokenizer.cc
  Pl_RC4.cc
  Pl_RunLength.cc
  Pl_SHA2.cc
  Pl_StdioFile.cc
  Pl_String.cc
  Pl_TIFFPredictor.cc
  QPDF.cc
  QPDFAcroFormDocumentHelper.cc
  QPDFAnnotationObjectHelper.cc
  QPDFArgParser.cc
  QPDFCryptoProvider.cc
  QPDFDocumentHelper.cc
  QPDFEFStreamObjectHelper.cc
  QPDFEmbeddedFileDocumentHelper.cc
  QPDFExc.cc
  QPDFFileSpecObjectHelper.cc
  QPDFFormFieldObjectHelper.cc
  QPDFJob.cc
  QPDFJob_argv.cc
  QPDFJob_config.cc
  QPDFJob_json.cc
  QPDFLogger.cc
  QPDFMatrix.cc
  QPDFNameTreeObjectHelper.cc
  QPDFNumberTreeObjectHelper.cc
  QPDFObject.cc
  QPDFObjectHandle.cc
  QPDFObjectHelper.cc
  QPDFOutlineDocumentHelper.cc
  QPDFOutlineObjectHelper.cc
  QPDFPageDocumentHelper.cc
  QPDFPageLabelDocumentHelper.cc
  QPDFPageObjectHelper.cc
  QPDFParser.cc
  QPDFStreamFilter.cc
  QPDFSystemError.cc
  QPDFTokenizer.cc
  QPDFUsage.cc
  QPDFWriter.cc
  QPDFXRefEntry.cc
  QPDF_Array.cc
  QPDF_Dictionary.cc
  QPDF_Stream.cc
  QPDF_String.cc
  QPDF_encryption.cc
  QPDF_json.cc
  QPDF_linearization.cc
  QPDF_optimization.cc
  QPDF_pages.cc
  QTC.cc
  QUtil.cc
  RC4.cc
  ResourceFinder.cc
  SecureRandomDataProvider.cc
  SF_FlateLzwDecode.cc
  qpdf-c.cc
  qpdfjob-c.cc
  qpdflogger-c.cc)

include(FindPkgConfig)
include(CheckTypeSize)
include(CheckIncludeFile)
include(CheckCSourceCompiles)
include(CheckCSourceRuns)
include(CheckSymbolExists)

set(dep_include_directories)
set(dep_link_directories)
set(dep_link_libraries)
set(ANYTHING_MISSING 0)

if(WIN32 AND (EXISTS ${qpdf_SOURCE_DIR}/external-libs))
  set(EXTERNAL_LIBS 1)
else()
  set(EXTERNAL_LIBS 0)
endif()

if(EXTERNAL_LIBS)
  set(EXTLIBDIR ${qpdf_SOURCE_DIR}/external-libs)
  list(APPEND dep_include_directories ${EXTLIBDIR}/include)
  set(JPEG_INCLUDE ${EXTLIBDIR}/include)
  list(APPEND dep_link_libraries
    z jpeg ssl crypto msvcrt ws2_32 shell32 advapi32 gdi32 user32 crypt32)
  if (MSVC)
    list(APPEND dep_link_directories ${EXTLIBDIR}/lib-msvc${WORDSIZE})
  else()
    list(APPEND dep_link_directories ${EXTLIBDIR}/lib-mingw${WORDSIZE})
  endif()
endif()

if(NOT EXTERNAL_LIBS)
  pkg_check_modules(pc_zlib zlib)
  if(pc_zlib_FOUND)
    list(APPEND dep_include_directories ${pc_zlib_INCLUDEDIR})
    list(APPEND dep_link_directories ${pc_zlib_LIBDIR})
    list(APPEND dep_link_libraries ${pc_zlib_LIBRARIES})
  else()
    find_path(ZLIB_H_PATH zlib.h)
    # cSpell:ignore zlibd
    find_library(ZLIB_LIB_PATH NAMES z zd zlib zlibd)
    if(ZLIB_H_PATH AND ZLIB_LIB_PATH)
      list(APPEND dep_include_directories ${ZLIB_H_PATH})
      list(APPEND dep_link_libraries ${ZLIB_LIB_PATH})
    else()
      message(SEND_ERROR "zlib not found")
      set(ANYTHING_MISSING 1)
    endif()
  endif()
endif()

if(NOT EXTERNAL_LIBS)
  pkg_check_modules(pc_libjpeg libjpeg)
  if(pc_libjpeg_FOUND)
    list(APPEND dep_include_directories ${pc_libjpeg_INCLUDEDIR})
    list(APPEND dep_link_directories ${pc_libjpeg_LIBDIR})
    list(APPEND dep_link_libraries ${pc_libjpeg_LIBRARIES})
    set(JPEG_INCLUDE ${pc_libjpeg_INCLUDEDIR})
  else()
    find_path(LIBJPEG_H_PATH jpeglib.h)
    find_library(LIBJPEG_LIB_PATH jpeg)
    if(LIBJPEG_H_PATH AND LIBJPEG_LIB_PATH)
      list(APPEND dep_include_directories ${LIBJPEG_H_PATH})
      list(APPEND dep_link_libraries ${LIBJPEG_LIB_PATH})
      set(JPEG_INCLUDE ${LIBJPEG_H_PATH})
    else()
      message(SEND_ERROR "libjpeg not found")
      set(ANYTHING_MISSING 1)
    endif()
  endif()
endif()

if(ZOPFLI)
  find_path(ZOPFLI_H_PATH NAMES zopfli.h PATH_SUFFIXES zopfli)
  find_library(ZOPFLI_LIB_PATH NAMES zopfli)
  if(ZOPFLI_H_PATH AND ZOPFLI_LIB_PATH)
    list(APPEND dep_include_directories ${ZOPFLI_H_PATH})
    list(APPEND dep_link_libraries ${ZOPFLI_LIB_PATH})
  else()
    message(SEND_ERROR "zopfli not found")
    set(ANYTHING_MISSING 1)
  endif()
endif()

# Update JPEG_INCLUDE in PARENT_SCOPE after we have finished setting it.
set(JPEG_INCLUDE ${JPEG_INCLUDE} PARENT_SCOPE)

# Crypto provider selection. Prefer external crypto providers. If
# implicit selection is allowed, use native only when no other options
# are available or when explicitly requested. Allowing native as a
# fallback can be disabled using the ALLOW_CRYPTO_NATIVE option.
list(APPEND CRYPTO_PKG)

set(USE_CRYPTO_GNUTLS OFF)
set(USE_CRYPTO_OPENSSL OFF)
set(USE_CRYPTO_NATIVE OFF)
set(FOUND_CRYPTO OFF)

if(USE_IMPLICIT_CRYPTO OR REQUIRE_CRYPTO_OPENSSL)
  if(EXTERNAL_LIBS)
    set(USE_CRYPTO_OPENSSL ON)
  else()
    pkg_check_modules(pc_openssl openssl>=1.1.0)
    if(pc_openssl_FOUND)
      set(USE_CRYPTO_OPENSSL ON)
      set(FOUND_CRYPTO ON)
      set(CRYPTO_PKG "${CRYPTO_PKG}, openssl >= 1.1.0")
    else()
      find_path(OPENSSL_H_PATH openssl/evp.h)
      find_library(OPENSSL_LIB_PATH crypto)
      if(OPENSSL_H_PATH AND OPENSSL_LIB_PATH)
        list(APPEND dep_include_directories ${OPENSSL_H_PATH})
        list(APPEND dep_link_libraries ${OPENSSL_LIB_PATH})
        set(USE_CRYPTO_OPENSSL ON)
        set(FOUND_CRYPTO ON)
      elseif(REQUIRE_CRYPTO_OPENSSL)
        message(SEND_ERROR "openssl not found")
        set(ANYTHING_MISSING 1)
      endif()
    endif()
  endif()
endif()
if(USE_IMPLICIT_CRYPTO OR REQUIRE_CRYPTO_GNUTLS)
  pkg_check_modules(pc_gnutls gnutls)
  if(pc_gnutls_FOUND)
    set(USE_CRYPTO_GNUTLS ON)
    set(FOUND_CRYPTO ON)
    set(CRYPTO_PKG "${CRYPTO_PKG}, gnutls")
  else()
    find_path(GNUTLS_H_PATH gnutls/gnutls.h)
    find_library(GNUTLS_LIB_PATH gnutls)
    if(GNUTLS_H_PATH AND GNUTLS_LIB_PATH)
      list(APPEND dep_include_directories ${GNUTLS_H_PATH})
      list(APPEND dep_link_libraries ${GNUTLS_LIB_PATH})
      set(USE_CRYPTO_GNUTLS ON)
      set(FOUND_CRYPTO ON)
    elseif(REQUIRE_CRYPTO_GNUTLS)
      message(SEND_ERROR "gnutls not found")
      set(ANYTHING_MISSING 1)
    endif()
  endif()
endif()
if(REQUIRE_CRYPTO_NATIVE)
  set(USE_CRYPTO_NATIVE ON)
  set(FOUND_CRYPTO ON)
elseif(USE_IMPLICIT_CRYPTO)
  if(ALLOW_CRYPTO_NATIVE AND (NOT FOUND_CRYPTO))
    set(USE_CRYPTO_NATIVE ON)
    set(FOUND_CRYPTO ON)
  endif()
endif()
if(FOUND_CRYPTO)
  if(NOT DEFAULT_CRYPTO)
    # The preferred order of crypto providers is documented in
    # manual/installation.rst in the crypto.build section.
    if(USE_CRYPTO_GNUTLS)
      set(DEFAULT_CRYPTO "gnutls")
    elseif(USE_CRYPTO_OPENSSL)
      set(DEFAULT_CRYPTO "openssl")
    else()
      set(DEFAULT_CRYPTO "native")
    endif()
  endif()
else()
  message(SEND_ERROR "no crypto provider is available")
  set(ANYTHING_MISSING 1)
endif()
if(ANYTHING_MISSING)
  message(FATAL_ERROR "Missing dependencies; unable to continue")
endif()

message(STATUS "")
message(STATUS "*** Crypto Summary ***")
message(STATUS "  GNU TLS crypto enabled: " ${USE_CRYPTO_GNUTLS})
message(STATUS "  OpenSSL crypto enabled: " ${USE_CRYPTO_OPENSSL})
message(STATUS "  Native crypto enabled: " ${USE_CRYPTO_NATIVE})
message(STATUS "  Default crypto: " ${DEFAULT_CRYPTO})
message(STATUS "")

if(USE_CRYPTO_OPENSSL)
  list(APPEND libqpdf_SOURCES ${libqpdf_crypto_openssl})
  if(NOT EXTERNAL_LIBS)
    list(APPEND dep_include_directories ${pc_openssl_INCLUDEDIR})
    list(APPEND dep_link_directories ${pc_openssl_LIBDIR})
    list(APPEND dep_link_libraries ${pc_openssl_LIBRARIES})
  endif()
endif()
if(USE_CRYPTO_GNUTLS)
  list(APPEND libqpdf_SOURCES ${libqpdf_crypto_gnutls})
  list(APPEND dep_include_directories ${pc_gnutls_INCLUDEDIR})
  list(APPEND dep_link_directories ${pc_gnutls_LIBDIR})
  list(APPEND dep_link_libraries ${pc_gnutls_LIBRARIES})
endif()
if(USE_CRYPTO_NATIVE)
  list(APPEND libqpdf_SOURCES ${libqpdf_crypto_native})
endif()

if(APPLE)
  # 2022: in CI (GitHub actions), pkg-config for zlib was adding a
  # broken directory to the include path. This effectively filters it
  # out.
  list(FILTER dep_include_directories EXCLUDE REGEX "^/Library/")
endif()

list(REMOVE_DUPLICATES dep_include_directories)
list(REMOVE_DUPLICATES dep_link_directories)
list(REMOVE_DUPLICATES dep_link_libraries)

check_type_size(size_t SIZEOF_SIZE_T)
check_include_file("inttypes.h" HAVE_INTTYPES_H)
check_symbol_exists(fseeko "stdio.h" HAVE_FSEEKO)
check_symbol_exists(fseeko64 "stdio.h" HAVE_FSEEKO64)
check_symbol_exists(localtime_r "time.h" HAVE_LOCALTIME_R)
check_symbol_exists(random "stdlib.h" HAVE_RANDOM)

check_c_source_compiles(
"#include <time.h>
#include <stdio.h>
int main(int argc, char* argv[]) {
    tzset();
    printf(\"%ld\", timezone);
    return 0;
}"
    HAVE_EXTERN_LONG_TIMEZONE)

check_c_source_compiles(
"#include <time.h>
int main(int argc, char* argv[]) {
    struct tm tm;
    tm.tm_gmtoff = 1;
    return 0;
}"
    HAVE_EXTERN_TM_GMTOFF)

check_c_source_compiles(
"#include <stdio.h>
#include <sys/types.h>
int main(int argc, char* argv[]) {
    int a[sizeof(off_t) >= 8 ? 1 : -1];
}"
    LFS_WITHOUT_MACROS)

check_c_source_compiles(
"#define _FILE_OFFSET_BITS 64
#include <stdio.h>
#include <sys/types.h>
int main(int argc, char* argv[]) {
    int a[sizeof(off_t) >= 8 ? 1 : -1];
}"
    LFS_WITH_MACROS)
if(LFS_WITH_MACROS AND NOT LFS_WITHOUT_MACROS)
  set(_FILE_OFFSET_BITS 64)
endif()

check_c_source_compiles(
"#include <malloc.h>
#include <stdio.h>
int main(int argc, char* argv[]) {
    malloc_info(0, stdout);
    return 0;
}"
    HAVE_MALLOC_INFO)

check_c_source_compiles(
"#include <stdio.h>
#include <stdlib.h>
int main(int argc, char* argv[]) {
    char* buf;
    size_t size;
    FILE* f;
    f = open_memstream(&buf, &size);
    fclose(f);
    free(buf);
    return 0;
}"
    HAVE_OPEN_MEMSTREAM)

configure_file(
  "${CMAKE_CURRENT_SOURCE_DIR}/qpdf/qpdf-config.h.in"
  "${CMAKE_CURRENT_BINARY_DIR}/qpdf/qpdf-config.h"
  NEWLINE_STYLE UNIX)

if(NOT BUILD_STATIC_LIBS)
  set(OBJECT_LIB_IS_PIC ON)
else()
  set(OBJECT_LIB_IS_PIC OFF)
endif()

# Build an "object library" for use in libtests so we don't have to
# export symbols that are not officially part of the public API. If we
# are building static libraries, the object library won't use
# position-independent code and will provided objects for the static
# library. If we are only building the shared library, go ahead and
# use PIC for the object library so we don't have to compile twice.
set(OBJECT_LIB libqpdf_object)
add_library(${OBJECT_LIB} OBJECT ${libqpdf_SOURCES})
if(OBJECT_LIB_IS_PIC)
  target_compile_definitions(${OBJECT_LIB} PRIVATE libqpdf_EXPORTS)
endif()
set_target_properties(${OBJECT_LIB} PROPERTIES
  POSITION_INDEPENDENT_CODE ${OBJECT_LIB_IS_PIC})
target_include_directories(${OBJECT_LIB}
  SYSTEM PRIVATE ${dep_include_directories})
target_include_directories(${OBJECT_LIB}
  PUBLIC
  ${JPEG_INCLUDE}
  ${qpdf_INCLUDE}
  ${qpdf_SOURCE_DIR}/libqpdf
  ${CMAKE_CURRENT_BINARY_DIR})
target_link_directories(${OBJECT_LIB} INTERFACE ${dep_link_directories})
target_link_libraries(${OBJECT_LIB} INTERFACE ${dep_link_libraries})
if(ATOMIC_LIBRARY)
  target_link_libraries(${OBJECT_LIB} INTERFACE ${ATOMIC_LIBRARY})
endif()

set(LD_VERSION_FLAGS "")
function(ld_version_script)
  # Check if the linker supports linker scripts, and use if it does.
  # This functionality is currently constrained to compilers using GNU
  # ld on ELF systems or systems that emulation this behavior.
  set(ld_script

=== debian/changelog ===
qpdf (12.0.0-2) unstable; urgency=medium

  * Upload to unstable.

 -- Jay Berkenbilt <qjb@debian.org>  Mon, 10 Mar 2025 07:07:30 -0400

qpdf (12.0.0-1) experimental; urgency=medium

  * New upstream release.
  * Bump soname to 30. Remove t64 transition material since libqpdf30 was
    introduced after the t64 transition.
  * Standards version updated to 4.7.2; no changes needed.

 -- Jay Berkenbilt <qjb@debian.org>  Sun, 09 Mar 2025 12:57:51 -0400
